Crash during negotiation if Role Selection Iltem has a UID length of 0
Description

In cases were an application sends a Associate Request with some wrong content, the application crashes.
Mathieu Malaterre reported this effect with storescp.

Example of the crash:

PDU Type: Associate Request, PDU Length: 237 + 6 bytes PDU header
: 01 00 00 00 00 ed 00 01 00 00 47 44 43 4d 5f 53
: 54 4f 52 45 20 20 20 20 20 20 47 44 43 4d 44 41
At the end there is the incomming item roleselectionitem
With Length 4

And a UID length of 0

Lodfile:
: Subitem parse: Type 54, Length 0004, Content: 49 46
: Parsing remaining 14 bytes of User Information
: Next item type: 32
: Parsing remaining 6 bytes of User Information
- Next item type: 30
: Parsing remaining 65534 bytes of User Information
: Next item type: 00
: Parsing remaining 65530 bytes of User Information
: Parsing remaining 65526 bytes of User Information
: Next item type: 00
: Parsing remaining 65522 bytes of User Information
: Next item type: 00
: Parsing remaining 65518 bytes of User Information
: Next item type: 00
: Parsing remaining 65514 bytes of User Information
: Next item type: 00
This wrong message should be recognized by demtk and either ignored or the connection have to be rejected.

Ideally the stack should recognize such pdu missmatch (wrong length of the item 54 coding, no uid length wrong scp/scu role) and

stop trying to parse the rest of the pdu.

History

#1 - 2013-07-25 21:39 - J6rg Riesmeier

- Tracker changed from Feature to Bug

A crash is not a feature but a bug ;)

#2 - 2013-08-15 19:19 - J6rg Riesmeier

- Subject changed from Crash during negotiation if roleselction Item as a UID length of 0. to Crash during negotiation if Role Selection Item has a UID

length of 0

#3 - 2017-04-16 14:35 - Marco Eichelberg
- File demtk_issue 536.bin added

- Status changed from New to Closed

- Assignee set to Marco Eichelberg

- % Done changed from 0 to 100

This bug has already been fixed by commit 1b6bb760 (December 2015), which fixed

several overflows/underflows in the ACSE code.

Attached is a file that can be sent to storescp using netcat and reproduces
the crash with storescp on DCMTK 3.6.0, but only leads to an error message
with newer versions:

Shell 1: storescp -Il trace 10000
Shell 2: netcat localhost 10000 <dcmtk_issue_536.bin

Closing this issue.

Files

s.log.gz 64.5 KB 2013-07-25 Andreas Thiel
storescp.cfg 8.34 KB 2013-07-25 Andreas Thiel
demtk_issue_536.bin 243 Bytes 2017-04-16 Marco Eichelberg
